<?php
class ControllerTotaldescontofaixavalorpedido extends Controller {
	private $error = array();

	const TIPO_ATIVO   = 1;
	const TIPO_INATIVO = 0;

	const TIPO_ACRESCIMO = 0;
	const TIPO_DESCONTO  = 1;

	const TIPO_PERCENTUAL = 1;
	const TIPO_MONETARIO  = 0;

	public function index() {
		$this->load->language('total/descontofaixavalorpedido');

		$this->document->setTitle($this->language->get('heading_title'));

    $this->load->model('setting/setting');

    $this->document->addScript(array(
      'view/javascript/module.total.descontofaixadevalorpedido.js'
    ));

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && ($this->validate()) ) {
			$this->model_setting_setting->editSetting('descontofaixavalorpedido', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->redirect($this->url->linkAnchor('extension/module', 'token=' . $this->session->data['token'], 'tab-info=' . $this->request->get['type'], 'SSL'));
		}

		$this->data['heading_title']        = $this->language->get('heading_title');
		$this->data['text_enabled']         = $this->language->get('text_enabled');
		$this->data['text_disabled']        = $this->language->get('text_disabled');
		$this->data['entry_status']         = $this->language->get('entry_status');

		$this->data['button_save']          = $this->language->get('button_save');
		$this->data['button_cancel']        = $this->language->get('button_cancel');
		$this->data['button_add_module']    = $this->language->get('button_add_module');
		$this->data['button_remove'] 	      = $this->language->get('button_remove');

		$this->data['text_Grlconf']         = $this->language->get('text_Grlconf');
		$this->data['text_tipooperacao']    = $this->language->get('text_tipooperacao');
		$this->data['text_valorbase']       = $this->language->get('text_valorbase');
		$this->data['text_status']          = $this->language->get('text_status');
		$this->data['text_ordem']           = $this->language->get('text_ordem');
		$this->data['text_status_validade'] = $this->language->get('text_status_validade');
		$this->data['text_tittle']          = $this->language->get('text_tittle');
		$this->data['text_price_range']     = $this->language->get('text_price_range');
		$this->data['text_type_discount']   = $this->language->get('text_type_discount');
		$this->data['text_value']           = $this->language->get('text_value');
		$this->data['text_date_expire']     = $this->language->get('text_date_expire');
		$this->data['text_percent']         = $this->language->get('text_percent');
		$this->data['text_monetary']        = $this->language->get('text_monetary');
		$this->data['text_discount']        = $this->language->get('text_discount');
		$this->data['text_add']             = $this->language->get('text_add');
		$this->data['text_products_total']  = $this->language->get('text_products_total');


		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		}else{
			$this->data['error_warning'] = '';
		}

		if (isset($this->error['error_percentual'])) {
		    $this->data['error_warning'] = $this->error['error_percentual'];
		}else{
		    $this->data['error_warning'] = '';
		}

		if (isset($this->error['error_perfil'])) {
			$this->data['error_warning'] = $this->error['error_perfil'];
		}else{
				$this->data['error_warning'] = '';
		}

		$this->data['breadcrumbs'] = array();

		$this->data['breadcrumbs'][] = array(
			'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
			'separator' => false
		);
		///?
		$this->data['breadcrumbs'][] = array(
			'text'      => $this->language->get('text_total'),
			'href'      => $this->url->linkAnchor('extension/module', 'token=' . $this->session->data['token'], 'tab-info=' . $this->request->get['type'], 'SSL'),
			'separator' => ' :: '
		);

		$this->data['breadcrumbs'][] = array(
			'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('total/descontofaixavalorpedido', 'token=' . $this->session->data['token'] . '&type=' . $this->request->get['type'], 'SSL'),
			'separator' => ' :: '
		);

		$this->data['action'] = $this->url->link('total/descontofaixavalorpedido', 'token=' . $this->session->data['token'] . '&type=' . $this->request->get['type'], 'SSL');

		$this->data['cancel'] = $this->url->linkAnchor('extension/module', 'token=' . $this->session->data['token'], 'tab-info=' . $this->request->get['type'], 'SSL');

		$this->load->model('setting/extension');

		$this->model_setting_setting->getSetting('descontofaixavalorpedido');

		if (isset($this->request->post['descontofaixavalorpedido_status'])) {
			$this->data['descontofaixavalorpedido_status'] = $this->request->post['descontofaixavalorpedido_status'];
		} else {
			$this->data['descontofaixavalorpedido_status'] = $this->config->get('descontofaixavalorpedido_status');
		}

		if (isset($this->request->post['descontofaixavalorpedido_tipo'])) {
			$this->data['descontofaixavalorpedido_tipo'] = $this->request->post['descontofaixavalorpedido_tipo'];
		} else {
			$this->data['descontofaixavalorpedido_tipo'] = $this->config->get('descontofaixavalorpedido_tipo');
		}

		if (isset($this->request->post['descontofaixavalorpedido_valor_base'])) {
			$this->data['descontofaixavalorpedido_valor_base'] = $this->request->post['descontofaixavalorpedido_valor_base'];
		} else {
			$this->data['descontofaixavalorpedido_valor_base'] = $this->config->get('descontofaixavalorpedido_valor_base');
		}

		if (isset($this->request->post['descontofaixavalorpedido_sort_order'])) {
			$this->data['descontofaixavalorpedido_sort_order'] = $this->request->post['descontofaixavalorpedido_sort_order'];
		} else {
			$this->data['descontofaixavalorpedido_sort_order'] = $this->config->get('descontofaixavalorpedido_sort_order');
		}

		if (isset($this->request->post['descontofaixavalorpedido_status_validade'])) {
			$this->data['descontofaixavalorpedido_status_validade'] = $this->request->post['descontofaixavalorpedido_status_validade'];
		} else {
			$this->data['descontofaixavalorpedido_status_validade'] = $this->config->get('descontofaixavalorpedido_status_validade');
		}

		$this->data['modules'] = array();

		if (isset($this->request->post['descontofaixavalorpedido_module'])) {
			$this->data['modules'] = $this->request->post['descontofaixavalorpedido_module'];
		} elseif ($this->config->get('descontofaixavalorpedido_module')) {
			$this->data['modules'] = $this->config->get('descontofaixavalorpedido_module');
    }

		$this->load->model('localisation/order_status');

		$this->data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		$this->children = array(
			'common/header',
			'common/footer',
		);

		$this->response->setOutput($this->render('total/descontofaixavalorpedido'));
	}

	private function validate() {
		if (!$this->user->hasPermission('modify', 'total/descontofaixavalorpedido')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if(isset($this->request->post['descontofaixavalorpedido_module'])){

		    $modules = $this->request->post['descontofaixavalorpedido_module'];

		    foreach($modules as $module){

		        if(($module['tipo_valor'] == ControllerTotaldescontofaixavalorpedido::TIPO_PERCENTUAL) && ($module['valor_desconto'] >= 100)){
		            $this->error['error_percentual'] = $this->language->get('text_error_percentual');
						}

						if($module['valor_perfil']==''){
							$this->error['error_perfil'] = $this->language->get('text_error_perfil');
						}

		    }
		}


		if (!$this->error) {
			return true;
		} else {
			return false;
		}

	}
}
